function [loes,zaehler] = modnewton(f,x0,RTol,ATol,df)
% function [loes,zaehler] = modnewton(f,x0,RTol,ATol,df)
% loes     Loesung des Systems
% zaehler  Anzahl der benoetigten Funktionsauswertungen
% f        Name des zu loesenden Systems
% x0       Startpunkt der Iteration
% RTtol    relative Toleranz
% ATol     absolute Toleranz
% Df       Name der Jacobi-Matrix-Funktion, falls vorhanden

global zaehler;
tau=0.5;
zaehler=0;
x=x0;
dx=RTol*norm(x)+ATol+1;
omega=1;
while norm(dx)>RTol*norm(x)+ATol
    f0=feval(f,x);
    zaehler=zaehler+1;
    DF=jacobi(f,df,x,f0);
    dx=-DF\f0;
    omega=1;
    while norm(feval(f,x+omega.*dx))>=(1-tau*omega)*norm(f0)
        omega=omega/2;
        zaehler=zaehler+1;
        if omega<1/256
            error('Divergenz');
        end;
    end;
    fprintf('O=%f\n',omega);
    x=x+omega*dx;
end;
loes=x;
