function [loes,zaehler] = newton(f,x0,RTol,ATol,df)
% function [loes,zaehler] = newton(f,x0,RTol,ATol,df)
% loes      Loesung des Systems
% zaehler   Anzahl der benoetigten Funktionsauswertungen
% f         Name des zu loesenden Systems
% x0        Startpunkt der Iteration
% RTtol     relative Toleranz
% ATol      absolute Toleranz
% Df        Name der Jacobi-Matrix-Funktion, falls vorhanden

global zaehler
zaehler=1;
f0=feval(f,x0);
DF=jacobi(f,df,x0,f0);
dx=-DF\f0;
x_0=x0+dx;
x_1=x0;
while norm(dx)>RTol*norm(x_0)+ATol
    x_2=x_1;
    x_1=x_0;
    f1=feval(f,x_1);
    zaehler=zaehler+1;
    DF=jacobi(f,df,x_1,f1);
    dx=-DF\f1;
    x_0=x_1+dx;
end;
loes=x_0;
