function nspoly, % Nullstellen von Polynomen
m=10; 
sole=[1:m]/m;
% sole=2.^(-[m-1:-1:0]);
x0=2;

p0=poly(sole);
maxiter=200;

% Newton + deconv
t=cputime;
sol=zeros(size(sole));
x=x0; p=p0;
while (length(p)>1)
    dp=polyder(p);
    f=polyval(p,x);
    lf=abs(f)+1;
    for i=1:maxiter
        if (abs(f)<=1e-12) | (abs(f)>=lf) break; end;
        lf=abs(f);
        x=x-f/polyval(dp,x);
        f=polyval(p,x);        
    end;
    sol(1,length(p)-1)=x;
    [p,r]=deconv(p,poly(x));
end;
t=cputime-t;
fprintf('Newton:   %6.4f sek  err=',t);
fprintf('%9.1e ',sort(sol)-sole);
fprintf('\n');

% Newton-Maehly
t=cputime;
x=x0; p=p0;
dp = polyder(p);
sol=zeros(size(sole));
for i=1:length(sole)
    x=x*1.1;
    y=polyval(p,x);     % aktueller Funktionswert
    xold=x+1;
    iter=0;
    while ((iter < 100) & (abs(y) + abs(x-xold) > 1e-12))
        xold = x;
        dpx=polyval(dp,x)-y*sum(1.0./(x - sol(1:i-1)));
        x = x - y/dpx;
        y=polyval(p,x);
        iter = iter + 1;
    end
    sol(i) = x;
end
t=cputime-t;
fprintf('N/Maehly: %6.4f sek  err=',t);
fprintf('%9.1e ',sort(sol)-sole);
fprintf('\n');

t=cputime;
n=length(p0);
sol=eig([[zeros(1,m-1);eye(m-1)],-p0(end:-1:2)'])';
t=cputime-t;
fprintf('Frobenius:%6.4f sek  err=',t);
fprintf('%9.1e ',sort(sol)-sole);
fprintf('\n\n');
